
#include <iostream.h>

/*

LoadMoz.exe - which preloads the mozilla modules.
Portions derived from TrayIcon.exe by Antti Markus (antti@pld.ttu.ee).

*/

#ifndef __GNUC__
//useful defines
#define STRICT
#define WIN32_LEAN_AND_MEAN
#endif

//standard includes
#include <windows.h>

//this is not defined in mingw32 versions prior to 2.95
#ifndef TPM_BOTTOMALIGN
#define TPM_BOTTOMALIGN     0x0020L
#endif

//additional includes
#include "trayicon.h"
#include "resource.h"
#include <atlbase.h>

//trayicon notification message
#define WM_TRAY   WM_USER+0x100+5


LRESULT CALLBACK WindowFunc(HWND, UINT, WPARAM, LPARAM);

const char* pClassName="TTWin32TrayApp123"; //window class name
HINSTANCE hMainInst=0;    //application main instance handle

HICON hIcon1=0;
HICON gCheckIcons[2];

unsigned uWhich=0;        //indicates which icon is displayed
HMENU hPopup=0;           //menu handle
CTrayIcon* pTrayIcon=0;   //pointer to trayicon class
static bool  gUseFullModuleList = false;

enum eAppVersion {eNetscape65, eNetscape60, eMozilla, eNetscapePre60, eUserPath,eUnknown};


//Constants for my DLL loader to use...
static char gMozPath[2048]= {0};
static char gUserPath[2048]= {0};
static char gMozModuleList[2048] = {0};
static const char* gModuleCP=gMozModuleList;

static int gMozPathLen=0;
static int gUserPathLen=0;

static const char *theMozPath=0;
static int  gDLLIndex=0;
static int  gTrayIconIndex = 0;


void Get60ModuleList(char *aBuffer) {
  
  static const char* theModuleList = 

    "nspr4;plds4;plc4;mozreg;xpcom;img3250;zlib;" \

    "gkgfxwin;gkwidget;" \

    "components\\gkparser;" \
    "jpeg3250;" \
    "js3250;" \
    "jsj3250;" \
    "jsdom;" \
    "components\\jsloader;" \

    "components\\activation;" \
    "components\\appcomps;" \
    "components\\addrbook;" \
    "components\\appshell;" \
    "components\\caps;" \
    "components\\chardet;" \
    "components\\chrome;" \
    "components\\cookie;" \
    "components\\docshell;" \
    "components\\editor;" \
    "components\\gkhtml;" \
    "components\\gkplugin;" \
    "components\\gkview;" \
    "gkwidget;" \
    "components\\jar50;" \
    "components\\lwbrk;" \
    "mozreg;" \
    "components\\necko;" \
    "components\\nsgif;" \
    "components\\nslocale;" \
    "components\\nsprefm;" \
    "components\\profile;" \
    "components\\psmglue;" \
    "components\\rdf;" \
    "components\\shistory;" \
    "components\\strres;" \
    "components\\txmgr;" \
    "components\\txtsvc;" \
    "components\\ucharuti;" \
    "components\\uconv;" \
    "components\\ucvlatin;" \
    "components\\ucvcn;" \
    "components\\ucvja;" \
    "components\\urildr;" \
    "components\\wallet;" \
    "components\\xpc3250;" \
    "components\\xpinstal;" \
    "components\\xppref32;" \
    "components\\mozbrwsr;" \
    "components\\nsjpg;" \
    "components\\oji;" \

    "msgbsutl;" \
    "components\\mork;" \
    "components\\msglocal;" \

    "xprt;" \
    "xptl;" \
    "xpcs";

  strcpy(aBuffer,theModuleList);

}

void Get65ModuleList(char *aBuffer) {
  static const char* theModuleList = 

  "nspr4;plds4;plc4;mozreg;xpcom;img3250;zlib;" \

  "gkgfxwin;gkwidget;" \

  "components\\gkparser;" \
  "jpeg3250;" \
  "js3250;" \
  "jsj3250;" \
  "jsdom;" \
  "components\\jsloader;" \

  "components\\activation;" \
  "components\\addrbook;" \
  "components\\appcomps;" \
  "components\\appshell;" \
  "components\\embedcomponents;"
  "components\\caps;" \
  "components\\chardet;" \
  "components\\chrome;" \
  "components\\cookie;" \
  "components\\docshell;" \
  "components\\editor;" \
  "components\\gkplugin;" \
  "components\\gkview;" \
  "gkwidget;" \
  "components\\jar50;" \
  "components\\lwbrk;" \
  "components\\necko;" \
  "components\\nsgif;" \
  "components\\nslocale;" \
  "components\\nsprefm;" \
  "components\\profile;" \
  "components\\psmglue;" \
  "components\\rdf;" \
  "components\\shistory;" \
  "components\\strres;" \
  "components\\txmgr;" \
  "components\\txtsvc;" \
  "components\\ucharuti;" \
  "components\\uconv;" \
  "components\\ucvlatin;" \
  "components\\ucvcn;" \
  "components\\ucvja;" \
  "components\\urildr;" \
  "components\\wallet;" \
  "components\\xpc3250;" \
  "components\\xpinstal;" \
  "components\\xppref32;" \
  "components\\xmlextras;" \

  "components\\gklayout;" \
  "components\\gkcontent;" \
  "components\\mozbrwsr;" \
  "components\\nsjpg;" \
  "components\\oji;" \

  "msgbsutl;" \
  "components\\mork;" \
  "components\\msglocal;" \

  "xprt;" \
  "xptl;" \
  "xpcs";
  
  strcpy(aBuffer,theModuleList);
}


void GetPathFromRegistry(eAppVersion aVersion, const char *&aKey, const char *&aSubkey, const char *&aModuleList) {
  
  switch(aVersion) { 
  
    case eMozilla:
      aKey = "Software\\Mozilla.org\\Mozilla\\0.8 (en)\\Main"; //
      aSubkey="Install Directory";
      Get65ModuleList(gMozModuleList);
      break;
    
    case eNetscape65:
      aKey = "Software\\Netscape\\Netscape 6\\6.5 (en)\\Main";
      aSubkey="Install Directory";
      Get65ModuleList(gMozModuleList);
      break;
    
    case eNetscape60:
      aKey = "Software\\Netscape\\Netscape 6\\6.0 (en)\\Main";
      aSubkey = "Path";
      Get60ModuleList(gMozModuleList);
      break;

    case eNetscapePre60:
      aKey  = "Software\\Microsoft\\Windows\\CurrentVersion\\App Paths\\netscp6.exe";
      aSubkey="Path";
      Get60ModuleList(gMozModuleList);
      break;

    case eUserPath:
      aKey  = 0;
      aSubkey= 0;
      strcpy(gMozPath,gUserPath);
      Get65ModuleList(gMozModuleList);
      break;

    case eUnknown:
      break;
  }
}

//Get the path to the netscape6 browser via the registry...
void GetMozillaRegistryInfo(eAppVersion aVersion) {

  const char *theKey=0;
  const char *theSubKey=0;

  //first we try to get the registry info based on the command line settings.
  //if that fails, we try others.

  LONG theOpenResult = 1; //any non-zero will do to initialize this...
  
  while(ERROR_SUCCESS!=theOpenResult) {
     
    GetPathFromRegistry(aVersion,theKey,theSubKey,gModuleCP);
    theOpenResult=ERROR_SUCCESS;

    CRegKey theRegKey;

    if(eUserPath!=aVersion) {
      theOpenResult=theRegKey.Open(HKEY_LOCAL_MACHINE,theKey,KEY_QUERY_VALUE);

      if(ERROR_SUCCESS==theOpenResult) {
        DWORD theSize=1024;

        theRegKey.QueryValue(gMozPath,theSubKey,&theSize);

        if((ERROR_SUCCESS==theOpenResult) && (aVersion!=eUserPath)) {

          theSize=1024;
          char theCachedModuleList[1024] = {0};

          theRegKey.QueryValue(theCachedModuleList,"Modules",&theSize);

          if(theCachedModuleList[0]) {
            strcpy(gMozModuleList,theCachedModuleList);
          }
          else {
            theRegKey.Create(HKEY_LOCAL_MACHINE,theKey);
            theRegKey.SetValue( HKEY_LOCAL_MACHINE, theKey, gMozModuleList, "Modules");
          }
        }

        break;
      }
    }
    aVersion=eAppVersion(int(aVersion)+1);
    
  } //while

  gMozPathLen=strlen(gMozPath);
  gModuleCP = gMozModuleList;

}


//This is a hard-coded list of DLL's we need (in the order we need them).
//Later on we should get this list from the registry.
void GetNextModuleName(char* aName) {
  //scan ahead to find the next ';' or the end of the string...
  bool done=false;
  char theChar=0;

  aName[0]=0;

  const char *theCP=gModuleCP;

  while(*theCP) {
    theChar=*theCP;
    if(';'==theChar)
      break;
    else theCP++;
  }

  if(theCP!=gModuleCP) {
    size_t theSize=theCP-gModuleCP;
    strncpy(aName,gModuleCP,theSize);
    aName[theSize]=0;
    gModuleCP=theCP;
    while(';'==*gModuleCP)
      gModuleCP++;
  }

}

//...

//the following types are fraudulent. They're just here so we can 
//wire up the function-type to GetModule...

const  int        gMaxProcIndex=256;
static HINSTANCE  gInstances[256];
static long*      gFuncTable[256][gMaxProcIndex];
static int        gDLLCount=0;

struct nsIID; 
typedef const nsIID& (*GetIIDFunc)(void);

HINSTANCE LoadModule(const char* aName) {

  //we operate on gMozPath directly to avoid an unnecessary string copy.
  //when we're done with this method, we reset gMozpath to it's original value for reuse.

  strcat(gMozPath,aName);
  strcat(gMozPath,".dll");

  gFuncTable[gDLLCount][0]=0; //make sure the table looks empty by default.
  
  HINSTANCE theInstance=gInstances[gDLLCount++]=LoadLibrary(gMozPath);

  int theEntryCount=0;

  if(theInstance) {
    //let's get addresses throughout the module, skipping over every 20.
    for(int theEntryPoint=0;theEntryPoint<64;theEntryPoint++){
      long *entry=(long*)::GetProcAddress(theInstance,MAKEINTRESOURCE(1+(20*theEntryPoint)));
      if(entry) {
        gFuncTable[gDLLCount-1][theEntryCount++]=entry;
        gFuncTable[gDLLCount][theEntryCount]=0; //always add a null to the end
      }
    }
  }

  gMozPath[gMozPathLen]=0;
  return theInstance;
}


//This function get's called repeatedly to call GetProcAddr()
//which tries to keep the DLL's from being paged.

VOID CALLBACK KeepAliveTimerProc(
  HWND hwnd,     // handle of window for timer messages
  UINT uMsg,     // WM_TIMER message
  UINT idEvent,  // timer identifier
  DWORD dwTime   // current system time
  ) {

  static bool theTimerIsRunning=false;
  static int  theCurrentModule=0;
  static int  theCurrentProc=0;

  if(!theTimerIsRunning) { //ignore other timer calls till we're done.
    theTimerIsRunning=true;

    const int stepSize=40; //how many modules to "touch" each time...

    int theCount=0;

    for(int theSteps=0;theSteps<stepSize;theSteps++) {

      long *p=(long*)gFuncTable[theCurrentModule++][theCurrentProc];
      if (p && (*p)){  
        //don't actually invoke it, just cause it to load into memory...

        //note that modules have different number of entry points.
        //so not all modules have an entry point at theCurrentProc index.
      }
     
      if(theCurrentModule>=gDLLCount) {
        theCurrentModule=0; //loop back around to top of module list...
        theCurrentProc++;
        if(theCurrentProc>=gMaxProcIndex){
          theCurrentProc=0; //reset this too!
        }
      }

    }

    theTimerIsRunning=false;
  }
}


//this function get's called repeatedly until we've loaded all the DLL's. 
static HWND gMyWnd;

VOID CALLBACK LoadModuleTimerProc(
  HWND hwnd,     // handle of window for timer messages
  UINT uMsg,     // WM_TIMER message
  UINT idEvent,  // timer identifier
  DWORD dwTime   // current system time
  ) {

  static bool theTimerIsRunning=false;

  if(!theTimerIsRunning) {
    theTimerIsRunning=true;

    pTrayIcon->Modify(gCheckIcons[gTrayIconIndex]);
    gTrayIconIndex = (gTrayIconIndex==1) ? 0 : gTrayIconIndex+1;

    char theDLLName[512];
    GetNextModuleName(theDLLName);

    if(theDLLName[0]) {
      HINSTANCE theInstance=LoadModule(theDLLName);
    }
    else {
      KillTimer(gMyWnd,2);     
      pTrayIcon->Modify(gCheckIcons[1]);
      
      //now make a new one that calls GetProcAddr()...
      UINT result=SetTimer(gMyWnd,2,50,KeepAliveTimerProc);
      
    }

    theTimerIsRunning=false;
  }
}
 
/****************************************
  we support the following args:
    -f(+/-) : use FULL module list
    -m : use mozilla installation
    -n : use netscape installation (this is the default)
    -p : use the given path (use this when you're running from a debug build rather than an installed version)
 ****************************************/
void ParseArgs(LPSTR &CmdLineArgs,eAppVersion &anAppVersion) {

  const char* cp=CmdLineArgs;
  
  anAppVersion = eNetscape65; //by default.

  while(*cp) {
    char theChar=*cp;
    if(('-'==theChar) || ('/'==theChar)){
      //we found a valid command, go get it...
      ++cp;
      char theCmd=*cp;

      switch(theCmd) {
        case 'n':
        case 'N':
          anAppVersion=eNetscape65;
          break;

        case 'm':
        case 'M':
          anAppVersion=eMozilla;
          break;

        case 'f':
        case 'F':
          ++cp;          
          if('+'==*cp) {
            gUseFullModuleList=true;
          }
          break;

        case 'p':
        case 'P':
            //skip whitespace...
          cp++; //skip over the command, then get the install path the user wants us to use.
          anAppVersion=eUserPath;
          while(*cp) {
            if(' '!=*cp)
              break;
            cp++;
          }
            //now eat the path
          gMozPathLen=gUserPathLen=0;
          while(*cp) {
            if(' '!=*cp) {
              gUserPath[gUserPathLen++]=*cp;
            }
            cp++;
          }
          gUserPath[gUserPathLen]=0;
          continue;
          break;
        default:
          break;
      }
    }
    cp++; 
  }

}


int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPSTR lpszArgs,
                   int nWinMode)
{
  WNDCLASS WinClass;

  //register window class
  WinClass.hInstance=hInstance;
  hMainInst=hInstance;
  WinClass.lpszClassName=pClassName;  //specify class name
  WinClass.lpfnWndProc=WindowFunc;    //specify callback function
  WinClass.style=0;
  WinClass.hIcon=LoadIcon(NULL, IDI_APPLICATION); //specify icon
  WinClass.hCursor=LoadCursor(NULL, IDC_ARROW);   //specify cursor
  WinClass.lpszMenuName=0;
  WinClass.cbClsExtra=0;
  WinClass.cbWndExtra=0;
  WinClass.hbrBackground=(HBRUSH)GetStockObject(WHITE_BRUSH); //specify window background

  if(!RegisterClass(&WinClass))
    return 0;

  //create window
  HWND hwnd=CreateWindow(pClassName,
                         0,
                         WS_OVERLAPPEDWINDOW,
                         10,
                         10,
                         10,
                         10,
                         HWND_DESKTOP,
                         NULL,
                         hInstance,
                         NULL);

  //hide window
  ShowWindow(hwnd, SW_HIDE);

  bool useDebugModuleList=false;
  bool getPathFromRegistry=true;
  
  eAppVersion theAppVersion;

  ParseArgs(lpszArgs,theAppVersion);
  GetMozillaRegistryInfo(theAppVersion); 

  gMyWnd=hwnd;


  UINT result=SetTimer(hwnd,2,50,LoadModuleTimerProc);
  
  //start message pump
  MSG WinMsg;
  while(GetMessage(&WinMsg, NULL, 0, 0))
  {
    TranslateMessage(&WinMsg);
    DispatchMessage(&WinMsg);
  }

  return WinMsg.wParam;
}

LRESULT CALLBACK WindowFunc(HWND hwnd, UINT Msg,
                            WPARAM wParam, LPARAM lParam)
{
  switch(Msg)
  {
    //application starts up
    case WM_CREATE:
    {
      //initialize icons
      hIcon1=LoadIcon(hMainInst, MAKEINTRESOURCE(IDI_CHECK));

      gCheckIcons[0]=LoadIcon(hMainInst, MAKEINTRESOURCE(IDI_CHECK));
      gCheckIcons[1]=LoadIcon(hMainInst, MAKEINTRESOURCE(IDI_CHECK1));

      //initialize popup menu
      hPopup=LoadMenu(hMainInst, MAKEINTRESOURCE(IDR_MENU));

      //initialize tray icon
      pTrayIcon=new CTrayIcon(hwnd, WM_TRAY, IDI_DOTS1, gCheckIcons[0], "Checked");
      //put icon to system tray
      pTrayIcon->Put();
      break;
    }

    //notification from trayicon received
    case WM_TRAY:
    {
      //if right mouse button pressed
      if(lParam == WM_RBUTTONDOWN)
      {
        POINT pt;
        GetCursorPos(&pt);  //get cursor position
        SetForegroundWindow(hwnd);  //set window to foreground
        //display popup menu
        BOOL bRes=TrackPopupMenu(GetSubMenu(hPopup, 0), TPM_BOTTOMALIGN | TPM_RIGHTALIGN,
                                 pt.x, pt.y, 0, hwnd, 0);
        //send dummy message to window
        SendMessage(hwnd, WM_NULL, 0, 0);
      }
      break;
    }

    //notification from menu received
    case WM_COMMAND:
    {
      switch(LOWORD(wParam))
      {
        case IDM_EXIT:
        {
          DestroyWindow(hwnd);
          break;
        }

        //change icon in system tray
        case IDM_CHANGE:
        {
          if(!uWhich)
          {
            uWhich=1;
            pTrayIcon->Modify(hIcon1);
            pTrayIcon->Modify("Crossed");
          }
          else
          {
            uWhich=0;
            pTrayIcon->Modify(hIcon1);
            pTrayIcon->Modify("Checked");
          }
          break;
        }
      }
      break;
    }

    //exit application
    case WM_DESTROY:
    {
      //release used resources

      delete pTrayIcon;
      DestroyIcon(hIcon1);

      DestroyIcon(gCheckIcons[0]);
      DestroyIcon(gCheckIcons[1]);

      DestroyMenu(hPopup);
      PostQuitMessage(0);
      break;
    }

    default:
      return DefWindowProc(hwnd, Msg, wParam, lParam);
  }
  return 0;
}

