
/*
A simple C++ wrapper around WIN32 tray icon functions
Copyright (C) 2000 Antti Markus (antti@pld.ttu.ee)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef trayiconH
#define trayiconH

#ifndef __GNUC__ 
#define STRICT
#define WIN32_LEAN_AND_MEAN
#endif

#include <windows.h>
#include <shellapi.h>
                                            
//NB! NB!                                            
//If you're using mingw32 prior to version 2.95 then you have to uncomment the
//following #ifdef __GNUC__ ... #endif block

/*#ifdef __GNUC__

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct _NOTIFYICONDATAA {
        DWORD cbSize;
        HWND hWnd;
        UINT uID;
        UINT uFlags;
        UINT uCallbackMessage;
        HICON hIcon;
        CHAR   szTip[64];
} NOTIFYICONDATAA, *PNOTIFYICONDATAA;
typedef struct _NOTIFYICONDATAW {
        DWORD cbSize;
        HWND hWnd;
        UINT uID;
        UINT uFlags;
        UINT uCallbackMessage;
        HICON hIcon;
        WCHAR  szTip[64];
} NOTIFYICONDATAW, *PNOTIFYICONDATAW;
#ifdef UNICODE
typedef NOTIFYICONDATAW NOTIFYICONDATA;
typedef PNOTIFYICONDATAW PNOTIFYICONDATA;
#else
typedef NOTIFYICONDATAA NOTIFYICONDATA;
typedef PNOTIFYICONDATAA PNOTIFYICONDATA;
#endif // UNICODE

#define NIM_ADD         0x00000000
#define NIM_MODIFY      0x00000001
#define NIM_DELETE      0x00000002

#define NIF_MESSAGE     0x00000001
#define NIF_ICON        0x00000002
#define NIF_TIP         0x00000004

BOOL WINAPI Shell_NotifyIconA(DWORD dwMessage, PNOTIFYICONDATAA lpData);
BOOL WINAPI Shell_NotifyIconW(DWORD dwMessage, PNOTIFYICONDATAW lpData);
#ifdef UNICODE
#define Shell_NotifyIcon  Shell_NotifyIconW
#else
#define Shell_NotifyIcon  Shell_NotifyIconA
#endif // !UNICODE

#ifdef __cplusplus
}
#endif

#endif //end GNU specific */

class CTrayIcon
{
  NOTIFYICONDATA Data;  //trayicon data structure
  unsigned uTrayed; //indicates, if icon is in the tray
public:
  CTrayIcon(void);  //default constructor
  CTrayIcon(const HWND hwnd, const UINT uMsg, const UINT uID, 
            const HICON hIcon, const char* pTip);             //constructor
  ~CTrayIcon(void); //destructor
  void Init(const HWND hwnd, const UINT uMsg, const UINT uID, 
            const HICON hIcon, const char* pTip);             //initialize
  void Put(void);     //put icon to system tray
  void Remove(void);  //remove icon from system tray
  void Modify(const HICON hIcon); //change icon
  void Modify(const char* pTip);  //change tooltip
};

#endif
